// ------------------------------------------------------------
// Phong VF[fBO (slang:fragment program)
// 
// Copyright (c) 2003 IMAGIRE Takashi. All rights reserved.
// ------------------------------------------------------------

// -------------------------------------------------------------
// _vOtOgvOɓnf[^
// -------------------------------------------------------------
varying vec3 VERTEX_COLOR;
varying vec3 VERTEX_EYE;
varying vec3 VERTEX_NORMAL;
varying vec3 VERTEX_LIGHT;

// ------------------------------------------------------------
// tOgVF[_vO
// ------------------------------------------------------------
void main (void)
{
	vec3 N = normalize(VERTEX_NORMAL);	// @xNg
	vec3 L = normalize(VERTEX_LIGHT);	// CgxNg
	vec3 E = normalize(VERTEX_EYE);		// xNg
	vec3 R = reflect(L, N);				// ˃xNg
	
    // Phong speqular
    float spec = pow(max(dot(R, E), 0.0), 50.0);
	
	gl_FragColor = vec4 (VERTEX_COLOR, 1.0)			// _F
						 * vec4(max(dot(N,L), 0.0))	// Lambert gUx
				 + vec4 (0.8) * vec4 (spec);		// ʔːF
}
