// ------------------------------------------------------------
// Phong VF[fBO (slang:vertex program)
// 
// Copyright (c) 2003 IMAGIRE Takashi. All rights reserved.
// ------------------------------------------------------------

// -------------------------------------------------------------
// O[oϐ
// -------------------------------------------------------------
uniform vec3 LightPos;

// -------------------------------------------------------------
// _vOtOgvOɓnf[^
// -------------------------------------------------------------
varying vec3 VERTEX_COLOR;	// _F
varying vec3 VERTEX_EYE;	// xNg
varying vec3 VERTEX_NORMAL;	// @xNg
varying vec3 VERTEX_LIGHT;	// CgxNg

// ------------------------------------------------------------
// _VF[_vO
// ------------------------------------------------------------
void main(void)
{
	// Wϊ
	gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;
	
	// F̂߂̌vZ
    vec4 pos    = gl_ModelViewMatrix * gl_Vertex;
    vec3 L		= LightPos - vec3(pos);
    vec3 N      = gl_NormalMatrix * gl_Normal;

	VERTEX_COLOR = vec3(gl_Color);
	VERTEX_NORMAL = N;
	VERTEX_LIGHT  = L;
	VERTEX_EYE    = vec3(pos);
}
