//-------------------------------------------------------------
// File: main.cpp
//
// Desc: OpenGL AvP[V
//-------------------------------------------------------------
#pragma once
#include <windows.h>
#include "GLApp.h"
#include "main.h"

//-------------------------------------------------------------
// O[oϐ
//-------------------------------------------------------------
CMyD3DApplication* g_pApp  = NULL;
HINSTANCE          g_hInst = NULL;



//-------------------------------------------------------------
// Name: WinMain()
// Desc: C֐
//-------------------------------------------------------------
INT WINAPI WinMain( HINSTANCE hInst, HINSTANCE, LPSTR, INT nCmdShow)
{
    CMyD3DApplication d3dApp;

    g_pApp  = &d3dApp;
    g_hInst = hInst;

    if( FAILED( d3dApp.Create( hInst, nCmdShow ) ) )
        return 0;

	return d3dApp.Run();
}




//-------------------------------------------------------------
// Name: CMyD3DApplication()
// Desc: AvP[ṼRXgN^
//-------------------------------------------------------------
CMyD3DApplication::CMyD3DApplication()
{
	m_hProgramObject = 0;

	m_dwCreationWidth           = 512;
    m_dwCreationHeight          = 512;
    m_strWindowTitle            = TEXT( "main" );

    m_bLoadingApp               = TRUE;
}




//-------------------------------------------------------------
// Name: ~CMyD3DApplication()
// Desc: fXgN^
//-------------------------------------------------------------
CMyD3DApplication::~CMyD3DApplication()
{
}




//-------------------------------------------------------------
// Name: OneTimeSceneInit()
// Desc: xs
//		EBhȄ͏IĂ܂(Ђ傤͂܂)B
//		A3D ̏͏IĂ܂B
//-------------------------------------------------------------
HRESULT CMyD3DApplication::OneTimeSceneInit()
{
    // [fBObZ[W\
    SendMessage( m_hWnd, WM_PAINT, 0, 0 );

    m_bLoadingApp = FALSE;

    return S_OK;
}




//-------------------------------------------------------------
// Name: ConfirmDevice()
// Desc: ̎ɌĂ΂܂BKvȔ\͂`FbN܂B
//-------------------------------------------------------------
HRESULT CMyD3DApplication::ConfirmDevice( void* pCaps,
                     DWORD dwBehavior,    void* Format )
{
    return S_OK;
}





//-------------------------------------------------------------
// Name: InitDeviceObjects()
// Desc: foCXꂽ̏܂B
//		t[obt@tH[}bgfoCX̎ނς
//		ɒʉ߂܂B
//		ŊmۂDeleteDeviceObjects()ŊJ܂
//-------------------------------------------------------------
HRESULT CMyD3DApplication::InitDeviceObjects()
{
	HRESULT hr;
	
	// GLSL ̏
	hr = GLSL::Init();
	if (FAILED(hr)) {
		MessageBox( NULL, "Faild to initialize the shader system.", "ERROR", MB_OK);
		return FALSE;
	}

	// VF[_̓ǂݍ
	hr = GLSL::CreateShaderFromFile("GLSL", &m_hProgramObject);
	if (FAILED(hr)) {
		MessageBox( NULL, "Cannot install shader", "ERROR", MB_OK);
		return FALSE;
	}
	
	// IuWFNg̃P[V̏
	m_locLightPos = glGetUniformLocationARB(m_hProgramObject, "LightPos");


	return S_OK;
}




//-------------------------------------------------------------
// Name: DeleteDeviceObjects()
// Desc: InitDeviceObjects() ō쐬IuWFNgJ
//-------------------------------------------------------------
HRESULT CMyD3DApplication::DeleteDeviceObjects()
{
	if (m_hProgramObject){glDeleteObjectARB(m_hProgramObject);m_hProgramObject=NULL;}

    return S_OK;
}




//-------------------------------------------------------------
// Name: RestoreDeviceObjects()
// Desc: ʂ̃TCYύXꂽɌĂ΂܂B
//		mۂInvalidateDeviceObjects()ŊJ܂B
//-------------------------------------------------------------
HRESULT CMyD3DApplication::RestoreDeviceObjects()
{
	//vWFNV[hŎˉe
	GLdouble aspect = ((FLOAT)m_mysdBackBuffer.Width) / m_mysdBackBuffer.Height;
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
	gluPerspective( 60.0, aspect, 1.0, 10.0 );

	//m[}̃fr[[hֈڍs
	glMatrixMode( GL_MODELVIEW );

    return S_OK;
}




//-------------------------------------------------------------
// Name: InvalidateDeviceObjects()
// Desc: RestoreDeviceObjects() ō쐬IuWFNg̊J
//-------------------------------------------------------------
HRESULT CMyD3DApplication::InvalidateDeviceObjects()
{
    return S_OK;
}




//-------------------------------------------------------------
// Name: FinalCleanup()
// Desc: I钼ɌĂ΂
//-------------------------------------------------------------
HRESULT CMyD3DApplication::FinalCleanup()
{
    return S_OK;
}





float rot = 0;

//-------------------------------------------------------------
// Name: FrameMove()
// Desc: t[Ă΂܂BAj̏Ȃǂs܂B
//-------------------------------------------------------------
HRESULT CMyD3DApplication::FrameMove()
{
	rot = this->m_fTime;

	return S_OK;
}

// ---------------------------------------------------------------------------
// ̃IuWFNg
// ---------------------------------------------------------------------------
GLfloat CubeNormals[6][3] = 
 {  
  {+1.0,  0.0,  0.0}, {0.0, +1.0, 0.0}, {-1.0, 0.0, 0.0},
  { 0.0, -1.0,  0.0}, {0.0, 0.0,+1.0}, {0.0, 0.0, -1.0} 
 };

GLint CubeFaces[6][4] = 
 {  
  {0, 1, 2, 3}, {3, 2, 6, 7}, {7, 6, 5, 4},
  {4, 5, 1, 0}, {5, 6, 2, 1}, {7, 4, 0, 3} 
 };

GLfloat CubeVertices[8][3];  

static void InitializeCube(GLfloat v[8][3])
{
	v[0][0] = v[1][0] = v[2][0] = v[3][0] = -1;
	v[4][0] = v[5][0] = v[6][0] = v[7][0] = 1;
	v[0][1] = v[1][1] = v[4][1] = v[5][1] = -1;
	v[2][1] = v[3][1] = v[6][1] = v[7][1] = 1;
	v[0][2] = v[3][2] = v[4][2] = v[7][2] = 1;
	v[1][2] = v[2][2] = v[5][2] = v[6][2] = -1;
}

//-------------------------------------------------------------
// Name: Render()
// Desc: ʂ`悷.
//-------------------------------------------------------------
HRESULT CMyD3DApplication::Render(void)
{
	static int init=0;
	if(!init){init=1;
		// ̏
		InitializeCube(CubeVertices);
	}

	//EBhEhԂ
	glClearColor(0,0,0,0);
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

	//_̕ϊs̏
	glLoadIdentity();
	//_̌
	gluLookAt(	0.0, 3.0, 5.0,      // _
				0.0, 0.0, 0.0,      // ړ_
				0.0, 1.0, 0.0);		// 

	// VF[_̐؂ւ
	glUseProgramObjectARB(m_hProgramObject);

	// Cgʒu̐ݒ
	float lightPosition[3] = {2.0f, 8.0f, -10.0f };
	glUniform3fvARB(m_locLightPos, 1, &lightPosition[0]);

	// ̕`
	glPushMatrix();
		glRotated(100*rot, 0.0, 1.0, 0.0);

	for(int i = 0; i < 6; i++) {
		glBegin(GL_QUADS);	// lp`̕`

		glNormal3fv(&CubeNormals[i][0]);							// @
		glColor3d(CubeVertices[CubeFaces[i][0]][0]*0.5+0.5
				, CubeVertices[CubeFaces[i][0]][1]*0.5+0.5
				, CubeVertices[CubeFaces[i][0]][2]*0.5+0.5);		// _F
		glVertex3fv(&CubeVertices[CubeFaces[i][0]][0]);				// W
		glColor3d(CubeVertices[CubeFaces[i][1]][0]*0.5+0.5
				, CubeVertices[CubeFaces[i][1]][1]*0.5+0.5
				, CubeVertices[CubeFaces[i][1]][2]*0.5+0.5);		// _F
		glVertex3fv(&CubeVertices[CubeFaces[i][1]][0]);
		glColor3d(CubeVertices[CubeFaces[i][2]][0]*0.5+0.5
				, CubeVertices[CubeFaces[i][2]][1]*0.5+0.5
				, CubeVertices[CubeFaces[i][2]][2]*0.5+0.5);		// _F
		glVertex3fv(&CubeVertices[CubeFaces[i][2]][0]);
		glColor3d(CubeVertices[CubeFaces[i][3]][0]*0.5+0.5
				, CubeVertices[CubeFaces[i][3]][1]*0.5+0.5
				, CubeVertices[CubeFaces[i][3]][2]*0.5+0.5);		// _F
		glVertex3fv(&CubeVertices[CubeFaces[i][3]][0]);
    
		glEnd();	// lp`I
	}
	
	glPopMatrix();

	return S_OK;
}
//-------------------------------------------------------------
// Name: MsgProc()
// Desc: WndProc I[o[Ch
//-------------------------------------------------------------
LRESULT CMyD3DApplication::MsgProc( HWND hWnd, UINT msg,
                                 WPARAM wParam, LPARAM lParam )
{
	switch( msg )
    {
        case WM_PAINT:
        {
            if( m_bLoadingApp )
            {
                // [h
                HDC hDC = GetDC( hWnd );
                TCHAR strMsg[MAX_PATH];
                wsprintf(strMsg, TEXT("Loading... Please wait"));
                RECT rct;
                GetClientRect( hWnd, &rct );
                DrawText( hDC, strMsg, -1, &rct
                		, DT_CENTER|DT_VCENTER|DT_SINGLELINE );
                ReleaseDC( hWnd, hDC );
            }
            break;
        }

    }
    return CD3DApplication::MsgProc( hWnd, msg, wParam, lParam );
}


