//-----------------------------------------------------------------------------
// File: main.h
//
// Desc: Phong VF[fBO.
//-----------------------------------------------------------------------------
#ifndef MAIN_H
#define MAIN_H

#include "GLApp.h"
#include "GLSL.h"

//-------------------------------------------------------------
// Name: class CMyD3DApplication
// Desc: AvP[ṼNX
//-------------------------------------------------------------
class CMyD3DApplication : public CD3DApplication
{
	GLhandleARB m_hProgramObject;
	GLint		m_locLightPos;

	BOOL					m_bLoadingApp;	// [hH
protected:
    virtual HRESULT OneTimeSceneInit();
    virtual HRESULT InitDeviceObjects();
    virtual HRESULT RestoreDeviceObjects();
    virtual HRESULT InvalidateDeviceObjects();
    virtual HRESULT DeleteDeviceObjects();
    virtual HRESULT Render();
    virtual HRESULT FrameMove();
    virtual HRESULT FinalCleanup();
    virtual HRESULT ConfirmDevice( void*, DWORD, void* );

public:
    LRESULT MsgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam );
    CMyD3DApplication();
    virtual ~CMyD3DApplication();
};

#endif // !MAIN_H

